#!/bin/sh
if (echo "testing\c"; echo 1,2,3) | grep c >/dev/null; then
  if (echo -n testing; echo 1,2,3) | sed s/-n/xn/ | grep xn >/dev/null; then
    ac_n= ac_c='
' ac_t='	'
  else
    ac_n=-n ac_c= ac_t=
  fi
else
  ac_n= ac_c='\c' ac_t=
fi

if [ "$1" = "-elite" ]
then
  elite='true'
  shift
fi

if [ `uname` = "Linux" -a `uname -m` = "alpha" ]
then
 NORANDOM_HOLE="NORANDOM_HOLE"
fi

keyfile=$1
if [ -f $keyfile ]
then
  echo "Secret key $keyfile already exists! Exiting."
  exit 1
fi

RAND=/tmp/rand.$$
BITS=0
MIN=384
MAX=1024

cat <<EOF
Choose the size of your key. The smaller the key you choose the faster your 
server response will be, but you'll have less security. Keys of less than 512
bits are trivially cracked, while for high security applications you
probably don't want a key of less than 1024 bits. Choosing an appropriate
keysize is your responsibility.
EOF

while [ "$BITS" -lt "$MIN" -o "$BITS" -gt "$MAX" ]
do
  echo $ac_n "How many bits of key ($MIN minimum, $MAX maximum): $ac_c"
  read BITS
done

if [ "$NORANDOM_HOLE" = "NORANDOM_HOLE" ]
then
 FILES=""
 MULT=4
else
 MULT=2
cat <<EOF
Now we will generate some random data, using the truerand library
developed by Matt Blaze, Jim Reeds, and Jack Lacy at AT&T.
This may take some time.
EOF
if [ "$elite" ]
then
 touch $RAND
else
 makerand `expr $BITS \* $MULT` > $RAND
fi
fi

cat <<EOF

Now we generate more random data, from keystrokes
EOF
if [ "$elite" ]
then
 :
else
 keyrand `expr $BITS \* $MULT` >> $RAND
fi
cat <<EOF
Finally, choose some files with random bits, to complete our random
number seed generation. You might want to put in logfiles, utmp, wtmp,
etc.
EOF

elite=1
if [ "$elite" ]
then
 :
else
 echo $ac_n "Enter colon-seperated list of files: $ac_c"
 read FILES
fi
FILES="-rand $RAND:$FILES"

cat <<EOF
Now we are generating the key. This may also take some time. Be patient.

EOF

until genrsa $KEYCIPHER $FILES $BITS > $keyfile
do
  echo "Please try again."
done
rm $RAND

echo "Key generated"
